<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TIGL: PregelCombiner&lt; ALG_MESSAGE_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TIGL
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search", false, 'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Groups</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="classPregelCombiner-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">PregelCombiner&lt; ALG_MESSAGE_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__comp__engine.html">Computation Engine</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>pure combiner class in the Pregel engine It contains the definitions of the combine function and has few template implementations It is a template class that is parameterized by  
 <a href="classPregelCombiner.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglEnginePregelCombiner_8hpp_source.html">tiglEnginePregelCombiner.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:aeca1f2c7da196d3831c1eee739cf291b"><td class="memItemLeft" align="right" valign="top">uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCombiner.html#aeca1f2c7da196d3831c1eee739cf291b">combineMessages</a> (MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:aeca1f2c7da196d3831c1eee739cf291b"><td class="mdescLeft">&#160;</td><td class="mdescRight">empty core combine function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms  <a href="#aeca1f2c7da196d3831c1eee739cf291b">More...</a><br /></td></tr>
<tr class="separator:aeca1f2c7da196d3831c1eee739cf291b"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0a504caf4a20b568bd3eaf4e390a1bf1"><td class="memItemLeft" align="right" valign="top">uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCombiner.html#a0a504caf4a20b568bd3eaf4e390a1bf1">sumCombineMessages</a> (MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a0a504caf4a20b568bd3eaf4e390a1bf1"><td class="mdescLeft">&#160;</td><td class="mdescRight">implementation of sum combine function. it sums the data fields of all messages into a single message  <a href="#a0a504caf4a20b568bd3eaf4e390a1bf1">More...</a><br /></td></tr>
<tr class="separator:a0a504caf4a20b568bd3eaf4e390a1bf1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1b1cd59b4b0e47d2e7793040f8fd6b64"><td class="memItemLeft" align="right" valign="top">uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCombiner.html#a1b1cd59b4b0e47d2e7793040f8fd6b64">maxCombineMessages</a> (MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a1b1cd59b4b0e47d2e7793040f8fd6b64"><td class="mdescLeft">&#160;</td><td class="mdescRight">implementation of maximum combine function. it computes the maximum the data fields of all messages into a single message  <a href="#a1b1cd59b4b0e47d2e7793040f8fd6b64">More...</a><br /></td></tr>
<tr class="separator:a1b1cd59b4b0e47d2e7793040f8fd6b64"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0d4e525d1d8f7180c34078b9b6217b81"><td class="memItemLeft" align="right" valign="top">uint32&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classPregelCombiner.html#a0d4e525d1d8f7180c34078b9b6217b81">minCombineMessages</a> (MESSAGE_ITERATOR itIn, uint32 numMessages, MESSAGE_ITERATOR itOut)</td></tr>
<tr class="memdesc:a0d4e525d1d8f7180c34078b9b6217b81"><td class="mdescLeft">&#160;</td><td class="mdescRight">implementation of minimum combine function. it computes the minimum the data fields of all messages into a single message  <a href="#a0d4e525d1d8f7180c34078b9b6217b81">More...</a><br /></td></tr>
<tr class="separator:a0d4e525d1d8f7180c34078b9b6217b81"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename ALG_MESSAGE_TYPE&gt;<br />
class PregelCombiner&lt; ALG_MESSAGE_TYPE &gt;</h3>

<p>pure combiner class in the Pregel engine It contains the definitions of the combine function and has few template implementations It is a template class that is parameterized by </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">ALG_MESSAGE_TYPE</td><td>the data field of pregel messages </td></tr>
  </table>
  </dd>
</dl>
</div><h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aeca1f2c7da196d3831c1eee739cf291b"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32 <a class="el" href="classPregelCombiner.html">PregelCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::combineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>empty core combine function. Here it is an empty function that must be overridden by customized vertex definition for the different graph algorithms </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>number of combined output data messages </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a1b1cd59b4b0e47d2e7793040f8fd6b64"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32 <a class="el" href="classPregelCombiner.html">PregelCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::maxCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>implementation of maximum combine function. it computes the maximum the data fields of all messages into a single message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>number of combined output data messages (1 if there are messages, 0 if no messages) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0d4e525d1d8f7180c34078b9b6217b81"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32 <a class="el" href="classPregelCombiner.html">PregelCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::minCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>implementation of minimum combine function. it computes the minimum the data fields of all messages into a single message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>number of combined output data messages (1 if there are messages, 0 if no messages) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0a504caf4a20b568bd3eaf4e390a1bf1"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename ALG_MESSAGE_TYPE&gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint32 <a class="el" href="classPregelCombiner.html">PregelCombiner</a>&lt; ALG_MESSAGE_TYPE &gt;::sumCombineMessages </td>
          <td>(</td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itIn</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint32&#160;</td>
          <td class="paramname"><em>numMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">MESSAGE_ITERATOR&#160;</td>
          <td class="paramname"><em>itOut</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>implementation of sum combine function. it sums the data fields of all messages into a single message </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itIn</td><td>Iterator to input messages </td></tr>
    <tr><td class="paramname">numMessages</td><td>number of input messages </td></tr>
    <tr><td class="paramname">itOut</td><td>iterator to the start of the ouput message </td></tr>
  </table>
  </dd>
</dl>
<dl class="retval"><dt>Return values</dt><dd>
  <table class="retval">
    <tr><td class="paramname">the</td><td>number of combined output data messages (1 if there are messages, 0 if no messages) </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li>src/standard/engine/<a class="el" href="tiglEnginePregelCombiner_8hpp_source.html">tiglEnginePregelCombiner.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Tue Oct 14 2014 14:29:26 for TIGL by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
